"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactRedux = require("react-redux");

var _injectMessage = _interopRequireDefault(require("./injectMessage"));

var _getFirstError = _interopRequireDefault(require("./getFirstError"));

var _getUIInputField = _interopRequireDefault(require("./getUIInputField"));

var _createHandleUpdateValue = _interopRequireDefault(require("./createHandleUpdateValue"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var _default = function _default(options) {
  return function (WrappedComponent) {
    var _temp;

    if (!options) {
      console.error('redux-form-cc: options is requried!');
      return;
    }

    var formData = options.formData,
        renderUIInputField = options.renderUIInputField;

    if (!formData) {
      console.error('redux-form-cc: formData is requried!');
      return;
    }

    if (!renderUIInputField) {
      console.error('redux-form-cc: renderUIInputField is requried!');
      return;
    }

    return _temp =
    /*#__PURE__*/
    function (_PureComponent) {
      _inherits(ReduxFormCC, _PureComponent);

      function ReduxFormCC() {
        var _getPrototypeOf2;

        var _this;

        _classCallCheck(this, ReduxFormCC);

        for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(ReduxFormCC)).call.apply(_getPrototypeOf2, [this].concat(args)));

        _defineProperty(_assertThisInitialized(_this), "context", {});

        _defineProperty(_assertThisInitialized(_this), "state", {
          formState: {},
          firstError: ''
        });

        _defineProperty(_assertThisInitialized(_this), "unmount", false);

        _defineProperty(_assertThisInitialized(_this), "getFormState", function () {
          return (0, _injectMessage["default"])(formData(_this.context.store.getState()));
        });

        _defineProperty(_assertThisInitialized(_this), "componentDidMount", function () {
          _this.unsubscribe = _this.context.store.subscribe(_this.handleFormChange);

          _this.setState({
            formState: _this.getFormState()
          });
        });

        _defineProperty(_assertThisInitialized(_this), "handleFormChange", function () {
          if (_this.unmount) return;

          var formState = _this.getFormState();

          _this.setState(function () {
            return {
              formState: formState,
              firstError: (0, _getFirstError["default"])({
                formState: formState,
                options: options,
                getState: _this.context.store.getState
              })
            };
          });
        });

        _defineProperty(_assertThisInitialized(_this), "componentWillUnmount", function () {
          _this.unmount = true;

          _this.unsubscribe();
        });

        _defineProperty(_assertThisInitialized(_this), "indirectRenderWrappedComponent", function (value) {
          _this.context = value;
          var handleUpdateValue = (0, _createHandleUpdateValue["default"])({
            formState: _this.state.formState,
            dispatch: _this.context.store.dispatch,
            options: options
          });
          var form = (0, _getUIInputField["default"])({
            formState: _this.state.formState,
            handleUpdateValue: handleUpdateValue,
            options: options
          });
          var firstError = (0, _getFirstError["default"])({
            formState: _this.state.formState,
            options: options,
            getState: _this.context.store.getState
          });
          return _react["default"].createElement(WrappedComponent, _extends({}, _this.props, {
            formState: _this.state.formState,
            form: form,
            firstError: firstError
          }));
        });

        return _this;
      }

      _createClass(ReduxFormCC, [{
        key: "render",
        value: function render() {
          return _react["default"].createElement(_reactRedux.ReactReduxContext.Consumer, null, this.indirectRenderWrappedComponent);
        }
      }]);

      return ReduxFormCC;
    }(_react.PureComponent), _temp;
  };
};

exports["default"] = _default;