"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _default = function _default(_ref) {
  var formState = _ref.formState,
      options = _ref.options,
      dispatch = _ref.dispatch;
  return function (value, key) {
    var field = formState[key];

    if (!field) {
      console.error("redux-form-cc: Cannot get field in formData at key '".concat(key, "'. Please recheck your formData"));
      return;
    }

    var fieldAction = field.action || options.action;

    if (!fieldAction) {
      console.error('redux-form-cc: action is required!');
      return;
    }

    dispatch(fieldAction({
      key: key,
      value: value
    }));
  };
};

exports["default"] = _default;