"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _isFunction = _interopRequireDefault(require("./isFunction"));

var _getErrorMessage = _interopRequireDefault(require("./getErrorMessage"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var _default = function _default(_ref) {
  var formState = _ref.formState,
      options = _ref.options,
      store = _ref.store;
  var mapStateToValidationPriority = options.mapStateToValidationPriority;

  if ((0, _isFunction["default"])(mapStateToValidationPriority)) {
    var priority = mapStateToValidationPriority(store);
    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
      for (var _iterator = priority[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
        var key = _step.value;
        var field = formState[key];

        if (!field.hidden) {
          var errorMessage = (0, _getErrorMessage["default"])(field.value, field.rules);

          if (errorMessage !== '') {
            return (0, _getErrorMessage["default"])(field.value, field.rules);
          }
        }
      }
    } catch (err) {
      _didIteratorError = true;
      _iteratorError = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion && _iterator["return"] != null) {
          _iterator["return"]();
        }
      } finally {
        if (_didIteratorError) {
          throw _iteratorError;
        }
      }
    }
  }

  for (var _key in formState) {
    var _field = formState[_key];

    if (!_field.hidden) {
      var _errorMessage = (0, _getErrorMessage["default"])(_field.value, _field.rules);

      if (_errorMessage !== '') {
        return (0, _getErrorMessage["default"])(_field.value, _field.rules);
      }
    }
  }

  return '';
};

exports["default"] = _default;