"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = require("react");

var _reactRedux = require("react-redux");

var _injectMessage = _interopRequireDefault(require("./injectMessage"));

var _getFirstError = _interopRequireDefault(require("./getFirstError"));

var _getUIInputField = _interopRequireDefault(require("./getUIInputField"));

var _createHandleUpdateValue = _interopRequireDefault(require("./createHandleUpdateValue"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var useReduxFormCC = function useReduxFormCC(options) {
  if (!options) {
    console.error('redux-form-cc: options is requried!');
    return;
  }

  var formData = options.formData,
      renderUIInputField = options.renderUIInputField;

  if (!formData) {
    console.error('redux-form-cc: formData is requried!');
    return;
  }

  if (!renderUIInputField) {
    console.error('redux-form-cc: renderUIInputField is requried!');
    return;
  }

  var dispatch = (0, _reactRedux.useDispatch)();
  var store = (0, _reactRedux.useSelector)(function (s) {
    return s;
  });
  var getFormState = (0, _react.useCallback)(function () {
    return (0, _injectMessage["default"])(formData(store));
  }, [formData, store]);
  var formState = getFormState();
  var firstError = (0, _getFirstError["default"])({
    formState: formState,
    options: options,
    store: store
  });
  var handleUpdateValue = (0, _createHandleUpdateValue["default"])({
    formState: formState,
    options: options,
    dispatch: dispatch
  });
  return {
    formState: formState,
    form: (0, _getUIInputField["default"])({
      formState: formState,
      handleUpdateValue: handleUpdateValue,
      options: options
    }),
    firstError: firstError
  };
};

var _default = useReduxFormCC;
exports["default"] = _default;